SystemOrganization addCategory: #'OCMS-Interface'!

WAComponent subclass: #CommentAddView
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CommentAddView methodsFor: 'initialization' stamp: 'has 6/29/2013 20:14'!
initialize
	super initialize.
	comment := Comment new.! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:20'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: comment];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:18'!
renderContentOn: html
	html heading level: 1; with: 'New comment'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderTextOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CommentAddView methodsFor: 'rendering' stamp: 'has 6/29/2013 20:54'!
renderTextOn: html
	html div: [
		html label: 'Your comment'.
		html textArea
			callback: [:value | comment text: value.
							comment dateAndTime: DateAndTime now.
							"comment user:'User session'."
						].
	].! !

WAComponent subclass: #ConfirmView
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!ConfirmView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 01:05'!
on: aQuestion
	^self basicNew
		initialize: aQuestion;
		yourself.! !

!ConfirmView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize: aQuestion
	self initialize.  
	question := aQuestion.  ! !

!ConfirmView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:06'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: true];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: false];
			with: 'Cancel'.
	].! !

!ConfirmView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:18'!
renderContentOn: html
	html paragraph: question.
	html form: [
		self renderButtonsOn: html.
	]! !

WAComponent subclass: #CourseAddView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseAddView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize
	super initialize.
	course := Course new.! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:36'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: course];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:32'!
renderCategoryOn: html
	html div: [
		html text: 'Category: [TODO]'.
	]! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:01'!
renderContentOn: html
	html heading level: 1; with: 'New course'.
	html text: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			"renderCategoryOn: html;"
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CourseAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:31'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | course description: value].
	]! !

WAComponent subclass: #CourseEditView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseEditView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:00'!
on: aCourse
	^self basicNew
		initialize: aCourse;
		yourself.! !

!CourseEditView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:21'!
initialize: aCourse
	self initialize.  
	course := aCourse.
.! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 01:53'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: course];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:49'!
renderContentOn: html
	html heading level: 1; with: 'Edit course ', course description.
	html paragraph: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!CourseEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:37'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html text: course description.
	]! !

WAComponent subclass: #CourseListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 02:20'!
addCourse
	| component answer |
	component := CourseAddView new.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(CourseManager new) includeCourse: answer.
					self inform: ('Course successfully added.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Could not add it due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 02:33'!
deleteCourse: aCourse
	| component answer courseManager |
	component := ConfirmView on: 'Are you sure you want to delete this course?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				courseManager := CourseManager new.
				[
					courseManager removeCourse: aCourse.
					self inform: ('Course successfully deleted.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Could not delete it due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'updating' stamp: 'oda 7/1/2013 02:19'!
editCourse: aCourse
	| component answer |
	component := CourseEditView on: aCourse.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(CourseManager new) updateCourse: answer.
					self inform: ('Course successfully updated.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Could not update it due to ', sig asString)
				].
		].
! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:12'!
renderAddAnchorOn: html
	html anchor
		callback: [self addCourse];
		with: 'New course'.
	html break.! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 6/30/2013 23:32'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Courses'.
	html paragraph: [
		self renderAddAnchorOn: html.  
	].
	self renderItemsOn: html.  ! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:54'!
renderItem: aCourse on: html
	html tableRow: [
		html tableData: [
			html anchor
				callback: [self call: (GroupListView on: aCourse)];
				with: [html strong:aCourse description].
		].
	"""There are no fields to be edited""
		html tableData: [
			html anchor
				callback: [self editCourse: aCourse];
				with: 'Edit'.
		].
	"
		html tableData: [
			html anchor
				callback: [self deleteCourse: aCourse];
				with: 'Delete'.
		]
	]! !

!CourseListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 00:59'!
renderItemsOn: html
	| courseList |
	courseList := Courses getAll.
	html table: [
		courseList do: [:each | self renderItem: each on: html].
	]! !

WAComponent subclass: #CoursewareDetailsView
	instanceVariableNames: 'courseware file score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareDetailsView methodsFor: 'updating' stamp: 'has 6/29/2013 20:44'!
addComment
	| comment component |
	component  := CommentAddView new.
	comment := self call: component.
	
	(comment isMemberOf: Comment)
		ifTrue: [
				[	
					(CoursewareManager new) includeComment: courseware comment: comment.
					self inform: ('Your comment was successfully registered.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not add the comment due to ', sig asString)].
		].! !

!CoursewareDetailsView methodsFor: 'updating' stamp: 'has 7/1/2013 09:33'!
addRating: aScore
	| component |
	component := self.
	(self session user isNil)
		 ifFalse: [
				[	"usertest:= User new. login:'higortest';username:'Hig Test';email:'higtest@hig.com'."
					(CoursewareManager new) includeOrUpdateCoursewareScore: courseware ofUser: (self session user) withScore: self score.
					self inform: ('Your rate was successfully registered.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not add your rate due to ', sig asString)].
		].! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:12'!
back
	self answer.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:44'!
courseware
	^courseware.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:43'!
courseware: aCourseware
	courseware:= aCourseware.! !

!CoursewareDetailsView methodsFor: 'downloading' stamp: 'has 7/1/2013 07:44'!
downloadFile
	"I get the file of the courseware stored from uploads directory and download to the user"
	| stream content |
	file := WAFile new.
	file fileName: courseware file.

	stream := (StandardFileStream fileNamed: 'uploads/',courseware file).
	content := stream contents.
	stream close.
	file contents: content.
	
	courseware downloadCounter: courseware downloadCounter + 1.
	(CoursewareManager new) updateCourseware: courseware.
	
	self requestContext respond: [ :response |
		response 
            contentType: file contentType;
            document: file rawContents;
		attachmentWithFileName: file fileName ]! !

!CoursewareDetailsView methodsFor: 'initialization' stamp: 'has 7/1/2013 09:05'!
initialize
	super initialize.! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:24'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: courseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Back to Coursewares'.
	html break.
	html table:[
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Id'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Description'.
						html tableData: courseware description.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Summary'.
						html tableData: courseware summary.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courseware type'.
						html tableData: courseware coursewareType.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Owner'.
						html tableData: courseware owner username.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Reference'.
						html tableData: courseware reference.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Tags'.
						html tableData: [courseware tagString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courses'.
						html tableData: [courseware courseString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Authors'.
						html tableData: courseware authorString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Created at:'.
						html tableData: courseware creationDateTime asTimeStamp.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Modified at:'.
						html tableData: courseware modificationDateTime.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Cataloguing data'.
						html tableData: courseware cataloguingData.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'License'.
						html tableData: courseware license asString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'File name'.
						html tableData: courseware file.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Size'.
						html tableData: (courseware size) asString, ' bytes'.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'No. downloads'.
						html tableData: courseware downloadCounter.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Enabled'.
						html tableData: courseware isEnabled.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Rating score'.
						html tableData: courseware calculateRatingScore.].
	].
	html break.
	(courseware file ~= '')
	ifTrue:[	html anchor
				callback: [self downloadFile];
				with: 'Download'.
			html break.].
	html break.
	self renderRatingOn: html.
	html break.
	html anchor
		callback: [self addComment];
		with: 'Add a comment'.
	html break.
	html heading level: 3;
		with: 'Comments'.
	html table:[ courseware comment do: [:each | 
		html tableRow:[
						(html tableHeading) align:'left'; with: 'User'.
						html tableData: (each login).
		].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Comment'.
						html tableData: (each text).].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Date'.
						html tableData: (each dateAndTime asTimeStamp).
		].
		]].! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 7/1/2013 09:17'!
renderRatingOn: html
	| groupRating |
	html form: [
		html label: 'Rating'.
		groupRating := html radioGroup.
		groupRating radioButton
			callback:[score:= 1].
		html text: '1'.
		groupRating radioButton
			callback:[score:= 2].
		html text: '2'.
		groupRating radioButton
			callback:[score:= 3].
		html text: '3'.
		groupRating radioButton
			callback:[score:= 4].
		html text: '4'.
		groupRating radioButton
			callback:[score:= 5].
		html text: '5'.
		html space.
		html button
			callback: [self addRating: score ];
			with: 'Add'.
	].! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 7/1/2013 08:33'!
score
	^score.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 7/1/2013 08:32'!
score: aScore
	score:= aScore.! !

WAComponent subclass: #CoursewareEditView
	instanceVariableNames: 'courseware authorValue tagValue courseValue courseList file fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 14:31'!
addAuthor: anAuthor
	| component authorList authorTemp |
	authorTemp := anAuthor trimBoth.
	component  := self.
	authorList := self courseware author.
	[
		((authorTemp = ''))
			ifFalse:[
					(courseware authorExists: authorTemp)
						ifFalse:[	authorList add: authorTemp.
								courseware author: authorList.
								self inform: ('The author was successfully registered.').]
						ifTrue:[self inform: ('The author already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null authors cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 12:00'!
addCourse: aCourse
	| component courseList |
	component  := self.
	courseList := self courseware course.
	[
		(courseware courseExists: aCourse)
			ifFalse:[	courseList add: aCourse.
					courseware course: courseList.
					self inform: ('The course was successfully registered.').]
			ifTrue:[self inform: ('The course already exists in this courseware.').].
	]
	on: Error
		do: [:sig | self inform: ('Could not add the course due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 11:38'!
addTag: aTag
	| component newTag tagList tagManager tagTemp |
	tagTemp := aTag trimBoth.
	component  := self.
	tagList := self courseware tag.
	tagManager := TagManager new.
	newTag:= Tag new.
	[
		((tagTemp = ''))
			ifFalse:[
						(Tags labelExists: tagTemp)
							ifFalse:[tagManager includeTag: tagTemp].
						(courseware tagExists: tagTemp)
							ifFalse:[	newTag label: tagTemp.
									tagList add: newTag.
									courseware tag: tagList.
									self inform: ('The tag was successfully registered.').]
							ifTrue:[self inform: ('The tag already exists in this courseware.').].
					]
			ifTrue:[self inform: ('Null tags cannot be added.')]
	]
	on: Error
		do: [:sig | self inform: ('Could not add the tag due to ', sig asString)].! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware
	^courseware! !

!CoursewareEditView methodsFor: 'accessing' stamp: 'has 6/29/2013 21:27'!
courseware: aCourseware
	courseware:=aCourseware.! !

!CoursewareEditView methodsFor: 'initialization' stamp: 'has 6/30/2013 13:39'!
initialize
	super initialize.
	courseList:= (Course new) searchAllCourses.! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 14:33'!
renderAuthorsAddOn: html
	html div: [
		html label: 'Add Authors:'.
		html textInput
			callback:[:value | authorValue := value].
		html space.
		html button
			callback: [self addAuthor: authorValue ];
			with: 'Add'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 14:34'!
renderAuthorsOn: html
	html div: [
		html label: 'Author:'.
		html label: courseware authorString.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/29/2013 23:32'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: courseware];
			with: 'Save'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 15:21'!
renderCataloguingDataOn: html
	html div: [
		html label: 'Cataloguing data:'.
		html textArea
			callback: [:value | courseware cataloguingData: value];
			with: courseware cataloguingData.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 18:52'!
renderContentOn: html
	html heading level: 1; with: 'Edit Courseware'.
	html text: 'Edit courseware information'. 
	
	html form: [
		self
			renderTitleOn: html;
			renderSummaryOn: html;
			renderDescriptionOn: html;
			renderCoursewareTypeOn: html;
			renderOwnerOn: html;
			renderTagsOn: html;
			renderTagsAddOn: html;
			renderCoursesOn: html;
			renderCoursesAddOn: html;
			renderAuthorsOn: html;
			renderAuthorsAddOn: html;
			renderCataloguingDataOn: html;
			renderLicenseTypeOn: html;
			renderEnabledOn: html;
			renderFileOn: html;
			renderSizeOn: html;
			renderUploadOn: html;
			renderButtonsOn: html; 
			yourself.  
	].  ! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 13:46'!
renderCoursesAddOn: html
	html div: [
		html label: 'Add Course:'.
		(html select) 
            	list: courseList;
			selected: courseValue;
			labels:[:ea | ea description];
			callback:[:value | courseValue := value].
		html space.
		html button
			callback: [self addCourse: courseValue ];
			with: 'Add'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 11:47'!
renderCoursesOn: html
	html div: [
		html label: 'Courses:'.
		html label: courseware courseString.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:24'!
renderCoursewareTypeOn: html
	html div: [
		html label: 'CoursewareType:'.
		html select 
            	list: CoursewareType coursewareTypeList; 
            	on: #coursewareType of: self courseware;
			callback: [:value | courseware coursewareType: value].
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:27'!
renderDescriptionOn: html
	html div: [
		html label: 'Description:'.
		html textArea
			callback: [:value | courseware description: value];
			with: courseware description.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 16:55'!
renderEnabledOn: html
	| group |
	html div: [
		html label: 'Enabled:'.
		group := html radioGroup.
		group radioButton
			selected: self courseware isEnabled;
			callback:[self courseware isEnabled:true.].
		html text: 'True'.
		group radioButton
			selected: self courseware isEnabled not;
			callback:[self courseware isEnabled:false.].
		html text: 'False'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 18:19'!
renderFileOn: html
	html div: [
		html label: 'File:'.
		html label: courseware file.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 15:51'!
renderLicenseTypeOn: html
	html div: [
		html label: 'License:'.
		html select 
            	list: LicenseType licenseTypeList; 
            	on: #license of: self courseware;
			callback: [:value | courseware license: value].
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:12'!
renderOwnerOn: html
	html div: [
		html label: 'Owner:'.
		html label: courseware owner username.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 07:15'!
renderReferenceOn: html
	html div: [
		html label: 'Reference:'.
		html textArea
			callback: [:value | courseware reference: value];
			with: courseware reference.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 7/1/2013 10:16'!
renderSizeOn: html
	html div: [
		html label: 'File size:'.
		html label: (courseware size) asString, ' bytes'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:29'!
renderSummaryOn: html
	html div: [
		html label: 'Summary:'.
		html textArea
			callback: [:value | courseware summary: value];
			with: courseware summary.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 18:37'!
renderTagsAddOn: html
	html div: [
		html label: 'Add Tags:'.
		html textInput
			callback:[:value | tagValue := value].
		html space.
		html button
			callback: [self addTag: tagValue ];
			with: 'Add'.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 11:47'!
renderTagsOn: html
	html div: [
		html label: 'Tags:'.
		html label: courseware tagString.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 08:17'!
renderTagsSearchOn: html for: type
	html div: [
		html label: 'Add Tags:'.
		html searchInput
			id: ('inputfield');
			onSearch: (Tags searchTagByLabel: type);
			onKeyUp: (Tags searchTagByLabel: type).
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 00:29'!
renderTitleOn: html
	html div: [
		html label: 'Title:'.
		html textArea 
			callback: [:value | courseware title: value];
			with: courseware title.
	].! !

!CoursewareEditView methodsFor: 'rendering' stamp: 'has 6/30/2013 18:45'!
renderUploadOn: html
	html div: [
		html anchor
		callback: [self uploadFile];
		with: 'Upload courseware'.
	].
	"html div: [
		html label: 'Upload courseware:'.
		html form multipart; with: [
		html fileUpload
			callback: [ :value | self receiveFile: value ].
        	html button
			callback:[self uploadFile];
			with: 'Send File'.]
	]."! !

!CoursewareEditView methodsFor: 'updating' stamp: 'has 6/30/2013 19:12'!
uploadFile
	| component |
	component  := UploadCourseware new.
	file := self call: component.
	
	[(file fileName ~= '')
		ifTrue: [
				courseware file: file fileName.
				courseware size: file size.
				courseware modificationDateTime: DateAndTime now.
				(CoursewareManager new) updateCourseware: courseware.
				self inform: ('Your file was successfully uploaded.').
				]
	]  
	on: Error
	do: [:sig | self inform: ('Could not add the file due to ', sig asString)].! !

WAComponent subclass: #CoursewareListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 11:14'!
back
	self answer.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:07'!
coursewareDetails: aCourseware on: html
	
	html heading level: 1; 
		with: aCourseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Coursewares'.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/30/2013 15:12'!
editCourseware: aCourseware
	| component courseware |
	component  := CoursewareEditView new.
	component courseware: aCourseware.
	courseware := self call: component.
	
	(courseware isMemberOf: Courseware)
		ifTrue: [
				[	courseware modificationDateTime: DateAndTime now.
					(CoursewareManager new) updateCourseware: courseware.
					self inform: ('Courseware successfully updated.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not update due to ', sig asString)].
		].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 14:58'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: 'Coursewares'.
	html break.
	html anchor
		callback: [self back];
		with: 'Home'.
	html unorderedList: [self renderItemsOn: html].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:05'!
renderItem: aCourseware on: html
	
	html listItem
		with: [html text: aCourseware title.
				html space.
				html anchor
					callback:[self showCoursewareDetails: aCourseware];
					with: 'details'.
				html space.
				html anchor
					callback:[self editCourseware: aCourseware];
					with: 'edit'.
				].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 13:25'!
renderItemsOn: html
	| coursewareList batchedList coursewareTitleList selection |
	coursewareList:= Coursewares getAll.
	coursewareList do:[:each | self renderItem: each on: html].
	"coursewareTitleList :=  OrderedCollection new.
	coursewareList do:[:each | coursewareTitleList add: each title]."
	"batchedList := WABatchedList new.
	batchedList items: coursewareTitleList asArray.
	batchedList batchSize: 10."
	"batchedList renderContentOn: html."
	"selection:= WABatchSelection items: coursewareList link: #id text: #title.
	selection batchSize: 20.
	selection onAnswer: [:item | self renderItem: item on:html]. 
	html render: selection."! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 16:12'!
showCoursewareDetails
	self call: (CoursewareDetailsView new).! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:04'!
showCoursewareDetails: aCourseware
	| coursewareDV |
	coursewareDV:=CoursewareDetailsView new.
	coursewareDV courseware: aCourseware.
	self call: (coursewareDV).! !

WAComponent subclass: #GroupAddView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupAddView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 03:55'!
initialize
	super initialize.
	group := Group new.! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:26'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: group];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:26'!
renderContentOn: html
	html heading level: 1; with: 'New group'.
	html text: 'Type the group''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderPasswordOn: html;  
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:36'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | group description: value].
	]! !

!GroupAddView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:11'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value |
				group password: value hash.
				group isOpen: value isEmpty.
			].
		html text: '(Empty creates an open group)'.
	].! !

WAComponent subclass: #GroupEditView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupEditView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:27'!
on: aGroup
	^self basicNew
		initialize: aGroup;
		yourself.  ! !

!GroupEditView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:27'!
initialize: aGroup
	self initialize.
	group := aGroup.    ! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:30'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: group];
			with: 'Confirm'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:51'!
renderContentOn: html
	html heading level: 1; with: 'Edit group ', group description.
	html paragraph: 'Type the course''s Info'. 
	
	html form: [
		self
			renderDescriptionOn: html;
			renderPasswordOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:29'!
renderDescriptionOn: html
	html div: [
		html label: 'Name:'.
		html text: group description.
	]! !

!GroupEditView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:13'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value |
				group password: value hash.
				group isOpen: value isEmpty.
			].
		html text: '(Empty creates an open group)'.
	].! !

WAComponent subclass: #GroupJoinView
	instanceVariableNames: 'group password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupJoinView class methodsFor: 'instance creation' stamp: 'oda 7/1/2013 02:57'!
on: aGroup
	^self basicNew
		initialize: aGroup;
		yourself.  ! !

!GroupJoinView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 02:57'!
initialize: aGroup
	self initialize.  
	group := aGroup.  ! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:20'!
joinGroup
	(group isOpen)
		ifTrue: [self answer: (self session user joinGroup: group)]
		ifFalse: [self answer: (self session user joinGroup: group withPassword: password)].
! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:25'!
renderButtonsOn: html
	html div: [ 
		html submitButton
			callback: [self joinGroup];
			with: 'Join'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:09'!
renderContentOn: html
	html paragraph: 'Are you sure you want to join this group?.'.  
	html form: [
		(group isOpen)
			ifFalse: [
				html paragraph: 'This group has a password.'.  
				self renderPasswordOn: html.  
			]. 
		self renderButtonsOn: html.
	]  ! !

!GroupJoinView methodsFor: 'rendering' stamp: 'oda 7/1/2013 03:06'!
renderPasswordOn: html
	html div: [ 
		html label: 'Password:'.
		html passwordInput
			callback: [:value | password := value];
			yourself.
	].! !

WAComponent subclass: #GroupListView
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!GroupListView class methodsFor: 'instance creation' stamp: 'oda 6/30/2013 21:14'!
on: aCourse
	^self basicNew
		initialize: aCourse;
		yourself.! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 03:54'!
addGroup
	| component answer |
	component := GroupAddView new.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(GroupManager new) includeGroup: answer atCourse: course byUser: (self session user).
					self inform: ('Group successfully added. Wait for an admin unlock it.').
				]  
				on: Error
				do: [:sig |
					course removeGroup: answer.
					self inform: ('Could not add due to ', sig asString)
				].
		].! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 02:40'!
deleteGroup: aGroup
	| component answer groupManager |
	component := ConfirmView on: 'Are you sure you want to delete this group?'.
	answer := self call: component.

	(answer)
		ifTrue: [	
				groupManager := GroupManager new.
				[
					groupManager removeGroup: aGroup.
					self inform: ('Group successfully deleted.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Could not delete it due to ', sig asString)
				].
		].
! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 02:34'!
editGroup: aGroup
	| component answer |
	component := GroupEditView on: aGroup.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
				[
					(GroupManager new) updateGroup: answer.
					self inform: ('Group successfully updated.').
				]  
				on: Error
				do: [:sig |
					OCMSDB session abort.
					self inform: ('Could not update it due to ', sig asString)
				].
		].
! !

!GroupListView methodsFor: 'initialize-release' stamp: 'oda 7/1/2013 01:49'!
initialize: aCourse
	self initialize.
	course := aCourse.  ! !

!GroupListView methodsFor: 'updating' stamp: 'oda 7/1/2013 03:29'!
joinGroup: aGroup
	| component answer |
	component := GroupJoinView on: aGroup.
	answer := self call: component.

	(answer notNil)
		ifTrue: [	
			(answer) "Joined?"
				ifTrue: [
					[
						(GroupManager new) updateGroup: aGroup.
						(UserManager new) updateUser: (self session user).  
						self inform: ('Joined.').
					]  
					on: Error
					do: [:sig |
						OCMSDB session abort.
						self inform: ('Could not update it due to ', sig asString)
					].
				] ifFalse: [
					self inform: ('Wrong password.')
				]  
		].
! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 00:00'!
renderAddAnchorOn: html
	html anchor
		callback: [self addGroup];
		with: 'New group'.
	html break.
! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 6/30/2013 23:33'!
renderContentOn: html
	html heading
		level: 1;
		with: 'Groups of ', course description.
	html paragraph: [
		self renderAddAnchorOn: html.
	].
	self renderItemsOn: html.! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 04:08'!
renderItem: aGroup on: html
	html tableRow: [
		html tableData: [
			html text: aGroup description.
		].
		html tableData: [
			((self session user group) includes: aGroup)
				ifFalse: [
					html anchor
						callback: [self joinGroup: aGroup];
						with: 'Join';
						yourself.
				]
		].
		html tableData: [
			html anchor
				callback: [self editGroup: aGroup ];
				with: 'Edit'.
		].	
		html tableData: [
			html anchor
				callback: [self deleteGroup: aGroup ];  
				with: 'Delete'.
		].
	].! !

!GroupListView methodsFor: 'rendering' stamp: 'oda 7/1/2013 02:35'!
renderItemsOn: html
	| groupList |
	groupList := course group.
	html table: [
		groupList do: [:each | self renderItem: each on: html].
	]! !

WAComponent subclass: #LoginComponent
	instanceVariableNames: 'login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!LoginComponent methodsFor: 'operating' stamp: 'oda 6/30/2013 21:45'!
authenticateUser
	| user |
	user := (UserManager new)
		authenticateUserWithLogin: login
		withPassword: password.
		self session user: user.
	user notNil
		ifTrue: [
			login := nil.
			password := nil.
		]! !

!LoginComponent methodsFor: 'operating' stamp: 'oda 7/1/2013 00:02'!
registerUser
	| component answer |
	login := nil. "clear warning"
	
	component  := UserRegistrationView new.
	answer := self call: component.
	
	(answer isMemberOf: User)
		ifTrue: [
				[
					(UserManager new) includeUser: answer.
					self inform: ('User successfully registered. Wait for an admin unlock it.').
				]  
				on: Error
				do: [:sig | self inform: ('Could not register due to ', sig asString)].
		].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:05'!
renderContentOn: html
	self session user isNil ifTrue: [
		self renderFormOn: html.  
	] ifFalse: [
		html heading: 'Welcome ', self session user login.
	]  
! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:07'!
renderFormOn: html
	html form
		class: 'loginForm';
		with: [ 
			self 
				renderWarningOn: html;
				renderLoginOn: html;
				renderPasswordOn: html;
				renderSubmitOn: html;
				yourself.
		].
	self renderRegisterAnchorOn: html.  ! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:07'!
renderLoginOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:33'!
renderPasswordOn: html
	html div: [ 
		html label: 'Password:'.
		html passwordInput
			callback: [:value | password := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:06'!
renderRegisterAnchorOn: html
	html anchor
		callback: [self registerUser];
		with: 'Register'.
	html break.! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 23:17'!
renderSubmitOn: html
	html div: [ 
		html submitButton
			callback: [self authenticateUser];
			with: 'Login'.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:05'!
renderUserOn: html
	html div: [ 
		html label: 'User:'.
		html textInput
			callback: [:value | login := value];
			yourself.
	].! !

!LoginComponent methodsFor: 'rendering' stamp: 'oda 6/29/2013 20:24'!
renderWarningOn: html
	html div: [
		html
			span: self warning;
			yourself.
	].! !

!LoginComponent methodsFor: 'operating' stamp: 'oda 6/29/2013 20:24'!
warning
	self session user notNil
		ifTrue: [	^'Logged in as ' , self session user login.].

	(login isNil or: [login isEmpty])
		ifTrue: [	^'Please enter User ID and Password'.].

	^'Login failed!!'.! !

WAComponent subclass: #OCMSHome
	instanceVariableNames: 'mainArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSHome class methodsFor: 'root' stamp: 'monnacs 6/26/2013 21:06'!
canBeRoot

 
^true! !

!OCMSHome class methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 20:10'!
initialize
"
	OCMSHome initialize
"
	super initialize.
	(self registerAsApplication: 'ocms')
		preferenceAt: #sessionClass put: OCMSSession;
		yourself.! !

!OCMSHome methodsFor: 'initialize-release' stamp: 'oda 6/30/2013 21:47'!
initialize
	| user |
	super initialize.
	
	user := self session user.
	mainArea := LoginComponent new.
	! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 02:16'!
renderContentOn: html
	"I render everything by calling html"
	html div
		id: 'allcontent';
		with: [
			self
				renderHeaderOn: html;
				renderMainOn: html;
				renderSidebarOn: html;  
				renderFooterOn: html;
				yourself.
		].! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 17:15'!
renderCourseAnchorOn: html
	html anchor
		callback: [mainArea := CourseListView new];
		with: 'Courses'.
	html break.! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:08'!
renderFooterOn: html
	html div
		id: 'footer';
		class: 'section';
		with: [
			html text: 'footer?'.
		].! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:07'!
renderHeaderOn: html
	html div
		id: 'header';
		class: 'section';
		with: [
			html heading
				level1;
				with: 'Open Courseware Management System'.
			html text: 'A system to store and share open courseware to academic institutions.'.
		].! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 17:07'!
renderHomeAnchorOn: html
	html anchor
		callback: [ mainArea := CoursewareListView new ];
		with: 'Home'.
	html break! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 17:00'!
renderLoginAnchorOn: html
	html anchor
		callback: [mainArea := LoginComponent new];
		with: 'Login'.
	html break.! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 21:47'!
renderLogoutAnchorOn: html
	html anchor
		callback: [
			self session user: nil.
			mainArea := LoginComponent new.
		];
		with: 'Logout'.
	html break.! !

!OCMSHome methodsFor: 'rendering' stamp: 'oda 6/30/2013 01:34'!
renderMainOn: html
	| user |
	user := self session user.
	html div
		id: 'main';
		class: 'section';
		with: [ html render: mainArea ].
! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 17:07'!
renderSidebarOn: html
	html div
		id: 'sidebar';
		class: 'section';
		with: [ 
			html heading
				level2;
				with: 'Menu'.
			self renderHomeAnchorOn: html.
			self renderUserOn: html
		]! !

!OCMSHome methodsFor: 'rendering-sidebar' stamp: 'oda 6/30/2013 17:00'!
renderUserOn: html
	self session user isNil ifTrue: [
		self renderLoginAnchorOn: html.
	] ifFalse: [
		self renderCourseAnchorOn: html.  
		self renderLogoutAnchorOn: html.
	].! !

!OCMSHome methodsFor: 'updating' stamp: 'oda 6/29/2013 23:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'OCMS'.
	anHtmlRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: OCMSFileLibrary / 'ocms.css';
		yourself.

	"old css
	anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css'"
! !

WAComponent subclass: #UploadCourseware
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UploadCourseware methodsFor: 'initialization' stamp: 'has 6/30/2013 19:08'!
initialize
	super initialize.
	file := WAFile new.! !

!UploadCourseware methodsFor: 'accessing' stamp: 'has 6/30/2013 19:01'!
receiveFile: aFile
    | stream |
    stream := (FileDirectory default directoryNamed: 'uploads')
		assureExistence;
		forceNewFileNamed: aFile fileName.
		file:= aFile.
		[ stream binary; nextPutAll: aFile rawContents ] 
		ensure: [ stream close ]! !

!UploadCourseware methodsFor: 'rendering' stamp: 'has 6/30/2013 19:02'!
renderContentOn: html
    html div: [
		html form multipart; with: [
        		html fileUpload
            		callback: [ :value | self receiveFile: value ].
        		html submitButton 
				callback: [self answer: file];
				with: 'Send File'.
			html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
		].
	].! !

WAComponent subclass: #UserRegistrationView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!UserRegistrationView methodsFor: 'initialize-release' stamp: 'oda 6/29/2013 18:18'!
initialize
	super initialize.
	user := User new.! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:39'!
renderButtonsOn: html
	html div: [
		html submitButton
			callback: [self answer: user];
			with: 'Register'.
		html cancelButton
			callback: [self answer: nil];
			with: 'Cancel'.
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:19'!
renderContentOn: html
	html heading level: 1; with: 'User Registration'.
	html text: 'Type your registration Info'. 
	
	html form: [
		self
			renderLoginOn: html;
			renderPasswordOn: html;
			renderUsernameOn: html;
			renderEmailOn: html;
			renderButtonsOn: html;  
			yourself.  
	].  ! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderEmailOn: html
	html div: [
		html label: 'Email:'.
		html textInput
			callback: [:value | user email: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 18:35'!
renderLoginOn: html
	html div: [
		html label: 'Login:'.
		html textInput
			callback: [:value | user login: value].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/30/2013 21:42'!
renderPasswordOn: html
	html div: [
		html label: 'Password:'.
		html passwordInput
			callback: [:value | user password: value hash].
	].! !

!UserRegistrationView methodsFor: 'rendering' stamp: 'oda 6/29/2013 19:18'!
renderUsernameOn: html
	html div: [
		html label: 'Name:'.
		html textInput
			callback: [:value | user username: value].
	].! !

WAFileLibrary subclass: #OCMSFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSFileLibrary methodsFor: 'as yet unclassified' stamp: 'oda 6/29/2013 23:38'!
ocmsCss
^'body {
	font-family: 			Georgia, "Times New Roman", Times, serif;
	font-size: 			small;
}
#allcontent {
	width: 				770px;
	padding-top: 		5px;
	padding-bottom: 	5px;
	background-color: 	#fff0d0;
	margin-left: 		auto;
	margin-right: 		auto;
}
*.section {
	background-color: 	#ffeabf;
}
#header {
	margin: 				10px;
}
#main {
	padding: 			15px;
	margin: 				0px 10px 10px 10px;
	width: 				550px;
	float: 				right;
}
#sidebar {
	padding: 			15px;
	margin: 				0px 600px 10px 10px;
}
#footer {
	color: 				#204670;
	text-align: 			center;
	padding: 			15px;
	margin: 				10px;
	clear: 				right;
}'! !

WASession subclass: #OCMSSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 20:42'!
user
	^user! !

!OCMSSession methodsFor: 'accessing' stamp: 'oda 6/29/2013 22:23'!
user: anUser
	user := anUser.! !
OCMSHome initialize!
